;Deze code wordt door de hoofdroutine in het RAM gezet en dan uitgevoerd, zodat
;we niet bang hoeven te zijn dat we een byte lezen uit de EEPROM terwijl die
;juist iets anders aan het doen is.

.org 0c200h
disploc .equ 0c000h
BuffPos .equ 0c003h
WriteHi .equ 0c004h
buffstart .equ 0c100h

Start:
   ;Bank 1 van de PV tevoorschijn halen...
   ld a,0
   ld (0),a

   ld a,1
   ld ($a003),a
   ld a,3
   ld ($6000),a
   nop
   nop

   ld a,($104)
   cp $ce
   jr nz,GaBrand
   ld a,($105)
   cp $ed
   jr nz,GaBrand
   ld a,($106)
   cp $66
   jr nz,GaBrand


   call GetButs
   cp 0
   jr nz,GaBrand

   ;Niet fikken -> inhoud van ROM vanaf $100 uitvoeren
   ;Eerst registers goedzetten

   ld a,1
   ld bc,$13
   ld de,$d8
   ld hl,$14d


   jp $100
   

GaBrand:

   ld a,3          ;LCDcont goed zetten...
   ldh (040h),a
   call dispoff
   call loadfont
   call dispoff

   ld a,0
   ldh (042h),a     ;scrollx=0
   ldh (043h),a     ;scrolly=0

   ;Wis ut scherm
   ld a,0
   ld hl,09800h
   ld bc,32*32
nietleeg:
   ld a,0
   ld (hl),a
   inc hl
   dec bc
   ld a,b
   or c
   cp 0
   jr nz,nietleeg

   ld a,-132
   ldh ($42),a

   ld a,010h
   ldh (041h),a

   ld a,098h
   ld (disploc),a
   ld a,0
   ld (disploc+1),a

   call dispon
   ;OK, initialisatie gedaan. Nu de echte code:

   call printd
   .db "Initialisation done.",13,0

   call printd
   .db "Init PV hardware",13,0

   ld a,0 ;Offset goed zetten
   ld (0h),a

   ld a,080h ;sndchip resetten
   ld (0a000),a

   ld a,0
   ld (07000h),a
   ld a,3
   ld (06000h),a

   call printd
   .db "Synchronizing...",13,0

;OK, initialisation is finished, now to try to get the link online...
notsyncedyet:
   ld a,080h ;\
   ldh (1),a ; |=- Send 080h via external clock
   ldh (2),a ;/
wtotverz:
   ldh a,(2) ;SIO control register
   and 080h  ;mask Serial Transfer Flag
   cp 0      ;Byte already transfered?
   jr nz,wtotverz ;No -> wait a bit longer

   ;Byte has been sent, look what we received in return.

   ldh a,(1) ;SIO data register
   cp 0a0h   ;Is the byte 0a0h?
   jr nz,notsyncedyet ;No -> we're not synced yet -> try again.

   ;Allrightey, we have a working uplink!

   call printd
   .db "Synchronized.",13,0

   ld a,$c2     ; set flash rom write mode and voice chip record mode
   ld ($a000),a  ; (W)d2=1 Eop, d1=1 record, d0=1 play, d6=1 Flash Rom write enable

;Als aanwezig write-protection weghalen

   ld a,2
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,0aah
    ld (07555h),a
   ld a,082h
   ld (0a000h),a

   ld a,1
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,055h
    ld (06aaah),a
   ld a,082h
   ld (0a000h),a

   ld a,2
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,080h
    ld (07555h),a
   ld a,082h
   ld (0a000h),a

   ld a,2
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,0aah
    ld (07555h),a
   ld a,082h
   ld (0a000h),a


   ld a,1
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,055h
    ld (06aaah),a
   ld a,082h
   ld (0a000h),a


   ld a,2
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,020h
    ld (07555h),a
   ld a,082h
   ld (0a000h),a



   ld a,0
   ld (06000h),a
   ld a,0
   ld ($a003),a

   ld a,0
   ld (BuffPos),a
   ld (WriteHi),a

   call printd
   .db "Ready for data!",13,0


vast:
   ld a,(BuffPos)
   ldh (1),a
   ld a,$80
   ldh (2),a

WaitSent:
   ldh a,(2)
   and $80
   cp 0
   jr nz,WaitSent
   ;Kee, byte is ontvangen...

   ld hl,BuffStart
   ld a,(BuffPos)
   ld l,a

   ldh a,(1)
   ld (hl),a

   inc l

   ld a,l
   ld (BuffPos),a
   cp 0
   jr z,DoeSchrijf
   jp vast




DoeSchrijf:

   ld a,(WriteHi)
   and $e0
   srl a
   srl a
   srl a
   srl a
   srl a
   add a,4

   call flashcom

   ld a,(WriteHi)
   and $1f
   add a,$60
   ld b,a
   ld a,0
   ld c,a
   ld hl,BuffStart
WritePage:
   ldi a,(hl)
   ld (bc),a
   inc bc

   ld a,l
   cp 0
   jr nz,WritePage

   ld a,(WriteHi)
   inc a
   ld (WriteHi),a

   jr vast


flashcom:
   push af
   ld a,$82     ; set gameboy rom bank I/O write mode and voice chip record mode
   ld ($a000),a  ; (W)d2=1 Eop, d1=1 record, d0=1 play, d6=1 Flash Rom write enable (0 for rom bank I/O)
   ld a,2
   ld ($6000),a     ; set winbond flash rom bank
   xor   a
   ld ($7000),a
   ld a,$c2     ; set flash rom write mode and voice chip record mode
   ld ($a000),a  ; (W)d2=1 Eop, d1=1 record, d0=1 play, d6=1 Flash Rom write enable
   ld a,$aa
   ld ($7555),a     ; write $aa to $5555
   ld a,$82     ; set gameboy rom bank I/O write mode and voice chip record mode
   ld ($a000),a  ; (W)d2=1 Eop, d1=1 record, d0=1 play, d6=1 Flash Rom write enable (0 for rom bank I/O)
   ld a,1
   ld ($6000),a     ; set winbond flash rom bank
   ld a,$c2     ; set flash rom write mode and voice chip record mode
   ld ($a000),a  ; (W)d2=1 Eop, d1=1 record, d0=1 play, d6=1 Flash Rom write enable
   ld a,$55
   ld ($6aaa),a     ; write $55 to $2aaa
   ld a,$82     ; set gameboy rom bank I/O write mode and voice chip record mode
   ld ($a000),a  ; (W)d2=1 Eop, d1=1 record, d0=1 play, d6=1 Flash Rom write enable (0 for rom bank I/O)
   ld a,2
   ld ($6000),a     ; set winbond flash rom bank
   ld a,$c2     ; set flash rom write mode and voice chip record mode
   ld ($a000),a  ; (W)d2=1 Eop, d1=1 record, d0=1 play, d6=1 Flash Rom write enable
   ld a,$a0
   ld ($7555),a     ; write command to winbond flash rom
   ld a,$82     ; set gameboy rom bank I/O write mode and voice chip record mode
   ld ($a000),a  ; (W)d2=1 Eop, d1=1 record, d0=1 play, d6=1 Flash Rom write enable (0 for rom bank I/O)
   pop af
   ld ($6000),a  ; set current rom bank
   ld a,$c2     ; set flash rom write mode and voice chip record mode
   ld ($a000),a  ; (W)d2=1 Eop, d1=1 record, d0=1 play, d6=1 Flash Rom write enable
   ret
   
   
prog:
   push af
   ld a,2
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
   ld a,0aah
   ld (07555h),a
   ld a,082h
   ld (0a000h),a

   ld a,1
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
   ld a,055h
   ld (06aaah),a
   ld a,082h
   ld (0a000h),a

   ld a,2
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
   ld a,0a0h
   ld (07555h),a
   ld a,082h
   ld (0a000h),a

   ld a,0
   ld (06000h),a

   ld a,0c2h
   ld (0a000h),a
   pop af
   ld (hl),a
   ld a,082h
   ld (0a000h),a

   push hl
   ld hl,400
wl:
   dec hl
   ld a,h
   or l
   jr nz,wl
   pop hl

   ret


EraseChip:
   ld a,2
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,0aah
    ld (07555h),a
   ld a,082h
   ld (0a000h),a

   ld a,1
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,055h
    ld (06aaah),a
   ld a,082h
   ld (0a000h),a

   ld a,2
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,080h
    ld (07555h),a
   ld a,082h
   ld (0a000h),a

   ld a,2
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,0aah
    ld (07555h),a
   ld a,082h
   ld (0a000h),a

   ld a,1
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,055h
    ld (06aaah),a
   ld a,082h
   ld (0a000h),a

   ld a,2
   ld (06000h),a
   ld a,0c2h
   ld (0a000h),a
    ld a,010h
    ld (07555h),a
   ld a,082h
   ld (0a000h),a

   ret

crlf:
   .db 13,0

printd:
   ;Print de tekens na de CALL printd tot de 0 en gaat daar verder met uitvoeren.
   ld b,b
   pop hl
   call printstr
   inc hl
   push hl
   ret

hextab:
   .db "0123456789ABCDEF"
printa:
   push af
   push bc
   push de
   push hl
   call waitvbl
   push af
   ld a,(disploc)
   ld b,a
   ld a,(disploc+1)
   ld c,a
   pop af

   push af
   ld hl,hextab
   swap a
   and 0fh
   ld d,0
   ld e,a

   add hl,de
   ld a,(hl)
   ld (bc),a
   inc bc
   pop af

   ld hl,hextab
   and 0fh
   ld d,0
   ld e,a

   add hl,de
   ld a,(hl)
   ld (bc),a
   inc bc
   inc bc

   ld a,b
   ld (disploc),a
   ld a,c
   ld (disploc+1),a


   pop hl
   pop de
   pop bc
   pop af
   ret


printstr:
        ld a,(disploc)
        ld b,a
        ld a,(disploc+1)
        ld c,a
printstr1:
        call waitvbl
        ld a,(hl)
        cp 13
        jr z,return
        cp 0
        jr z,prnttrug
        
        ld (bc),a
        inc hl
        inc bc
        jr printstr1

prnttrug:
        ld a,b
        ld (disploc),a
        ld a,c
        ld (disploc+1),a
        ret


return:
   ldh a,($42)
   add a,8
   ldh ($42),a

   ld a,c
   and 0e0h
   ld c,a
   push hl
   ld hl,32
   add hl,bc
   ld b,h
   ld c,l
   pop hl

   ld a,b
   cp $9c
   jr nz,NietTeVer
   ld b,$98

NietTeVer:


   inc hl
   jp printstr1

loadfont:
        push af
        push bc
        push de
        push hl
        
        ld hl,font   ;label van data
        ld bc,09000h

        
        ld de,2064

loadfont2:
        ld a,(hl)
        ld (bc),a

        inc hl
        inc bc

        dec de
        ld a,d
        cp 0
        jr nz,loadfont2

        ld a,e
        cp 0
        jr nz,loadfont2


        call dispon
        pop hl
        pop de
        pop bc
        pop af
        ret

dispoff:
        push af
        ld a,(0ff40h)
        and 07fh
        ld (0ff40h),a
        pop af
        ret


dispon:
        push af
        ld a,(0ff40h)
        or 080h
        ld (0ff40h),a
        pop af
        ret




getbuts:
        push bc
        push de
        push hl
        ld	a,20h
	ld	(0ff00h),a	;turn on P15

	ld	a,(0ff00h)	;delay
	ld	a,(0ff00h)
	cpl
	and	0fh
	swap	a
	ld	b,a
	ld	a,10h
	ld	(0ff00h),a	;turn on P14
	ld	a,(0ff00h)	;delay
	ld	a,(0ff00h)
	ld	a,(0ff00h)
	ld	a,(0ff00h)
	ld	a,(0ff00h)
	ld	a,(0ff00h)
	cpl
	and	0fh
	or	b
	swap	a
        pop hl
        pop de
        pop bc
	ret

waitvbl:		; Wait for VBL
 push af
 ldh	a,(40h)
 add	a,a
 jr  nc,waitvbl2

waitvbl1:
 ldh	a,(44h)		; $ff44=LCDC Y-Pos
 cp	90h		; $90 and bigger = in VBL
 jr     nz,waitvbl1       ; Loop until it $90
waitvbl2:
 pop af
 ret


;Font-bestand. Staat het font in (geript v/d PC in screen 13 ;-) )
#include "font.inc"
   
.end
